<ion-content>
    <ion-toolbar>
        <ion-buttons slot="start">
            <ion-menu-button></ion-menu-button>
        </ion-buttons>
        <ion-item>
            <ion-label>{{ 'Visitor Logs' | translate }}</ion-label>
        </ion-item>
    </ion-toolbar>
    <ion-refresher slot="fixed" (ionRefresh)="onRefresh($event)">
        <ion-refresher-content pullingIcon="arrow-down" refreshingSpinner="circles">
        </ion-refresher-content>
    </ion-refresher>
    <div *ngIf="!this.cache?.isLoading">

        <ion-list *ngFor="let visitorLog of this.cache?.objects; index as i">

            <ion-card [routerLink]="['/society/visitor-logs/visitor-log-detail',visitorLog.id]">
                <ion-item>
                    <ion-avatar slot="start">
                        <img [src]="visitorLog.visitor.profilePicture.content">
                    </ion-avatar>
                    <ion-label>{{visitorLog?.visitor?.name}}</ion-label>
                    <ion-icon end *ngIf="visitorLog.unRead" name="mail-unread"></ion-icon>
                </ion-item>
                <div>
                    <ion-grid>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="person"></ion-icon>
                                {{visitorLog?.contactPerson?.name}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="home"></ion-icon>
                                {{visitorLog?.visitingTo?.name}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="time"></ion-icon>
                                {{getLocalTime(visitorLog.timeIn) | date:'medium'}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="exit"></ion-icon>
                                {{getLocalTime(visitorLog.timeOut) | date:'medium'}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <div *ngIf="visitorLog.isBookedInAdvance">
                                <ion-chip color="success">
                                    <ion-icon name="checkmark"></ion-icon>
                                    <ion-label>{{ 'Booked' | translate }}</ion-label>
                                </ion-chip>
                            </div>
                            <ion-chip color="success" *ngIf="visitorLog.approvalStatus === 'Approved'">
                                <ion-icon name="checkmark"></ion-icon>
                                <ion-label>{{ 'Approved' | translate }}</ion-label>
                            </ion-chip>
                            <ion-chip color="danger" *ngIf="visitorLog.approvalStatus === 'Rejected'">
                                <ion-icon name="close"></ion-icon>
                                <ion-label>{{ 'Rejected' | translate }}</ion-label>
                            </ion-chip>
                            <ion-chip color="warning" *ngIf="visitorLog.approvalStatus === 'Hold'">
                                <ion-icon name="hand"></ion-icon>
                                <ion-label>{{ 'Hold' | translate }}</ion-label>
                            </ion-chip>
                            <ion-chip color="primary" *ngIf="visitorLog.approvalStatus === 'Pending'">
                                <ion-icon name="stopwatch"></ion-icon>
                                <ion-label>{{ 'Pending' | translate }}</ion-label>
                            </ion-chip>
                        </ion-row>

                        <ion-row *ngIf="visitorLog?._cache_pending_operation == 'add'" style="color: orangered">
                            <ion-label>
                                <ion-icon name="alert"> </ion-icon>
                                {{ 'ADDED: not synced to server' | translate }}
                            </ion-label>
                        </ion-row>
                        <ion-row *ngIf="visitorLog?._cache_pending_operation == 'update'" style="color: goldenrod">
                            <ion-label>
                                <ion-icon name="alert">r</ion-icon>
                                {{ 'UPDATED: not synced to server' | translate }}
                            </ion-label>
                        </ion-row>
                        <ion-row *ngIf="visitorLog?._cache_pending_operation == 'delete'" style="color: red">
                            <ion-label>
                                <ion-icon name="alert">r</ion-icon>
                                {{ 'DELETED: not synced to server' | translate }}
                            </ion-label>
                        </ion-row>

                    </ion-grid>
                </div>
            </ion-card>
        </ion-list>
        <ion-card *ngIf="!this.cache?.isLoading && this.cache?.objects.length==0">
            <ion-item>
                <ion-label>{{ 'No records found!!!' | translate }}</ion-label>
            </ion-item>
        </ion-card>

        <ion-infinite-scroll threshold="100px" (ionInfinite)="loadNext($event)">
            <ion-infinite-scroll-content loadingSpinner="bubbles" loadingText="Loading ...">
                <ion-list *ngIf="this.cache?.isNextPageLoading">
                    <ion-card *ngFor="let a of ['','','']">
                        <ion-item>
                            <ion-thumbnail slot="start">
                                <ion-skeleton-text></ion-skeleton-text>
                            </ion-thumbnail>
                            <ion-skeleton-text animated></ion-skeleton-text>
                        </ion-item>
                        <div>
                            <ion-grid>
                                <ion-row>
                                    <ion-icon name="person"></ion-icon>
                                    <ion-skeleton-text animated animated style="width: 40%"></ion-skeleton-text>
                                </ion-row>
                                <ion-row>
                                    <ion-icon name="home"></ion-icon>
                                    <ion-skeleton-text animated animated style="width: 20%"></ion-skeleton-text>
                                </ion-row>
                                <ion-row>
                                    <ion-icon name="time"></ion-icon>
                                    <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                                </ion-row>
                                <ion-row>
                                    <ion-icon name="exit"></ion-icon>
                                    <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                                </ion-row>
                                <ion-row>
                                    <ion-chip style="width: 110px" >
                                    </ion-chip>
                                    <ion-chip style="width: 110px" >
                                    </ion-chip>
                                </ion-row>
                            </ion-grid>
                        </div>
                    </ion-card>
                </ion-list>
            </ion-infinite-scroll-content>
        </ion-infinite-scroll>
    </div>

    <ion-list *ngIf="this.cache?.isLoading && this.cache?.objects.length==0">
        <ion-card *ngFor="let a of ['','','','','','','','']">
            <ion-item>
                <ion-thumbnail slot="start">
                    <ion-skeleton-text></ion-skeleton-text>
                </ion-thumbnail>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-item>
            <div>
                <ion-grid>
                    <ion-row>
                        <ion-icon name="person"></ion-icon>
                        <ion-skeleton-text animated animated style="width: 40%"></ion-skeleton-text>
                    </ion-row>
                    <ion-row>
                        <ion-icon name="home"></ion-icon>
                        <ion-skeleton-text animated animated style="width: 20%"></ion-skeleton-text>
                    </ion-row>
                    <ion-row>
                        <ion-icon name="time"></ion-icon>
                        <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                    </ion-row>
                    <ion-row>
                        <ion-icon name="exit"></ion-icon>
                        <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                    </ion-row>
                    <ion-row>
                        <ion-chip style="width: 110px" >
                        </ion-chip>
                        <ion-chip style="width: 110px" >
                        </ion-chip>
                    </ion-row>
                </ion-grid>
            </div>
        </ion-card>
    </ion-list>
</ion-content>